/* eslint-disable require-jsdoc */
function sum(start=0, ...numbers: number[]) {
    let x = start;
    for (let i of numbers) {
        x += i;
    }
    return x;
}

/**
* @param {number} a
* @param {number} b
* @return {Array<number>}
*/
function divmod(a: number, b: number): number[] {
    return [Math.floor(a / b), a % b];
}

/**
* @param {number} base
* @param {number} exp
* @param {number} [modulo=1]
* @return {number}
*/
function pow(base: number, exp: number, modulo: number=1): number {
    if (exp < 0 && modulo) {
        throw Error('modulo must be ommited if the exponent is negative');
    }
    return Math.pow(base, exp) % modulo;
}

function round(number: number, precision?: number) {
    return Math.round(number).toPrecision(precision);
}

const abs = Math.abs;

export = {
    sum,
    abs,
    divmod,
    pow,
    round
};
